%define gitrev 4b474d

%define tarname spice
%define tarversion 0.1.0-git%{gitrev}

Name:           qspice
Version:        0.3.0
Release:        54%{?dist}
Summary:        An implementation of the Simple Protocol for Independent Computing Environments
Group:          User Interface/Desktops
License:        GPLv2+
URL:            http://www.qumranet.com/
Source0:        %{tarname}-%{tarversion}-server.tar.bz2
#patch0:         qspice-1.0-execute-usbrdrctrl.patch
patch1:         qspice-1.0-do-not-print-password.patch
patch2:         qspice-1.0-fix-unsecure-keyboard-message.patch
#patch3:         qspice-1.0-x11-set-input-focus.patch
#patch4:         qspice-1.0-fix-crash-on-enter-full-screen.patch
patch5:         qspice-1.0-change-to-CELT051.patch
patch6:         qspice-1.0-server-fix-migration-of-agent-write-queue-4.patch
#patch7:         qspice-1.0-client-linux-fix-deadlock-Timer-timers_act.patch
#patch8:         qspice-1.0-plug-linux-fix-retry-loop-in-SpiceControlle.patch
patch9:         qspice-0.3.0-change-configure-version.patch
patch10:        qspice-0.3.0-add-log-proc-to-CoreInterface.patch
#patch11:        qspice-0.3.0-client-don-t-exit-in-case-of-opening-audio.patch
patch12:        qspice-0.3.0-improve-audio-quality.patch
patch13:        qspice-0.3.0-server-fix-wrong-ret-val-in-snd_send_data.patch
patch14:        qspice-0.3.0-dont-set-null-display-mode-listener.patch
#patch15:        qspice-0.3.0-deleting-unix-domains-socket-files-from-tmp.patch
patch16:        qspice-0.3.0-use-cb_free-instead-of-close-in-inputs_re.patch
patch17:        qspice-0.3.0-fix-accessing-invalid-peer-in-reds-handle_inc.patch
patch18:        qspice-0.3.0-change-vendor-id-504194.patch
patch19:        qspice-0.3.0-spice-server-fix-is_same_geometry-508133.patch
patch20:        qspice-0.3.0-spice-server-improve-channel-connect-disconnect.patch
patch21:        qspice-0.3.0-spice-server-improve-video-stream-detection.patch
patch22:        qspice-0.3.0-spice-server-improve-video-streaming-in-low-network.patch
patch23:        qspice-0.3.0-spice-server-compress-inital-screen-image.patch
patch24:        qspice-0.3.0-spice-server-fail-net-test-on-invalid-values.patch
patch25:        qspice-0.3.0-spice-server-disable-ssl-compression.patch
patch26:        qspice-0.3.0-config-files-prepare-for-client-code-removal.patch
patch27:        qspice-0.3.0-spice-server-heuristic-for-distinguishing.patch
patch28:        qspice-0.3.0-spice-sever-remove-assert-on-nop-copy-bits.patch
patch29:        qspice-0.3.0-spice-sever-increase-client-timeout.patch
patch30:        qspice-0.3.0-spice-server-sending-destination-public-key.patch
patch31:        qspice-0.3.0-spice-fix-bug-551580.patch
patch32:        qspice-0.3.0-spice-server-avoid-video-streaming-of-small-images.patch
patch33:        qspice-0.3.0-spice-server-more-permissive-video-identification.patch
patch34:        qspice-0.3.0-spice-server-fix-wrong-access-to-ring-item.patch
BuildRoot:      %{_tmppath}/%{tarname}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  x86_64

BuildRequires:  gcc-c++
BuildRequires:  alsa-lib-devel
BuildRequires:  libpng-devel
BuildRequires:  libXrandr-devel
BuildRequires:  libXext-devel
BuildRequires:  log4cpp-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  openssl-devel
BuildRequires:  qcairo-devel
BuildRequires:  qffmpeg-devel
BuildRequires:  xulrunner-devel
BuildRequires:  boost-devel
BuildRequires:  zip
BuildRequires:  celt051-devel

%description
The Simple Protocol for Independent Computing Environments (SPICE) is
a remote display system built for virtual environments which allows
you to view a computing 'desktop' environment not only on the machine
where it is running, but from anywhere on the Internet and from a wide
variety of machine architectures.

%package libs
Summary:        Libraries for %{name}
Group:          System Environment/Libraries

%description libs
This package contains the runtime libraries for any application that wishes
to be a %{name} server.

%package libs-devel
Summary:        Header files, libraries and development documentation for %{name}
Group:          Development/Libraries
Requires:       %{name}-libs = %{version}-%{release}

Requires:       pkgconfig

Requires:       celt051-devel
Requires:       openssl-devel
Requires:       log4cpp-devel
Requires:       libpng-devel
Requires:       qcairo-devel >= 1.4.6
Requires:       qffmpeg-devel
Requires:       alsa-lib-devel
Requires:       libXrandr-devel
Requires:       xulrunner-devel >= 1.9
Requires:       nspr-devel >= 4.7.1
Requires:       libXext-devel


%description libs-devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.


%prep
%setup -q -n %{tarname}-%{tarversion}
#%patch0 -p 1 -b .execute-usbrdrctrl
%patch1 -p 1 -b .do-not-print-password
%patch2 -p 1 -b .fix-unsecure-keyboard-message
#%patch3 -p 1 -b .x11-set-input-focus
#%patch4 -p 1 -b .fix-crash-on-enter-full-screen
%patch5 -p 1 -b .change-to-CELT051
%patch6 -p 1 -b .server-fix-migration-of-agent-write-queue
#%patch7 -p 1 -b .client-linux-fix-deadlock-Timer-timers_actc
#%patch8 -p 1 -b .plug-linux-fix-retry-loop-in-SpiceControlle
%patch9 -p 1 -b .change-configure-version
%patch10 -p 1 -b .add-log-proc-to-CoreInterface
#%patch11 -p 1 -b .client-don-t-exit-in-case-of-opening-audio
%patch12 -p 1 -b .improve-audio-quality
%patch13 -p 1 -b .server-fix-wrong-ret-val-in-snd_send_data
%patch14 -p 1 -b .dont-set-null-display-mode-listener
#%patch15 -p 1 -b .deleting-unix-domains-socket-files-from-tmp
%patch16 -p 1 -b .use-cb_free-instead-of-close-in-inputs_re
%patch17 -p 1 -b .fix-accessing-invalid-peer-in-reds-handle_inc
%patch18 -p 1 -b .change-vendor-id
%patch19 -p 1 -b .spice-server-fix-is_same_geometry-508133
%patch20 -p 1 -b .spice-server-improve-channel-connect-disconnect
%patch21 -p 1 -b .spice-server-improve-video-stream-detection
%patch22 -p 1 -b .spice-server-improve-video-streaming-in-low-network
%patch23 -p 1 -b .spice-server-compress-inital-screen-image
%patch24 -p 1 -b .spice-server-fail-net-test-on-invalid-values
%patch25 -p 1 -b .spice-server-disable-ssl-compression
%patch26 -p 1 -b .config-files-prepare-for-client-code-removal
%patch27 -p 1 -b .spice-server-heuristic-for-distinguishing
%patch28 -p 1 -b .spice-sever-remove-assert-on-nop-copy-bits
%patch29 -p 1 -b .spice-sever-increase-client-timeout
%patch30 -p 1 -b .spice-server-sending-destination-public-key
%patch31 -p 1 -b .spice-fix-bug-551580
%patch32 -p 1 -b .spice-server-avoid-video-streaming-of-small-images
%patch33 -p 1 -b .spice-server-more-permissive-video-identification
%patch34 -p 1 -b .spice-server-fix-wrong-access-to-ring-item


%build
CFLAGS="%{optflags}"; CFLAGS="${CFLAGS/-Wall/}"; export CFLAGS;
CXXFLAGS="%{optflags}"; CXXFLAGS="${CXXFLAGS/-Wall/}"; export CXXFLAGS;
FFLAGS="%{optflags}"; FFLAGS="${FFLAGS/-Wall/}"; export FFLAGS;
LOG4CPP_CFLAGS="%{optflags}"; LOG4CPP_CFLAGS="${LOG4CPP_CFLAGS/-Wall/}"; export LOG4CPP_CFLAGS;
%configure
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT


%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, 0755)
%doc COPYING INSTALL README

%files libs
%defattr(-, root, root, 0755)
%doc COPYING README
%{_libdir}/libspice.so.*

%files libs-devel
%defattr(-, root, root, 0755)
%doc COPYING README
%{_includedir}/libspice/
%{_libdir}/libspice.so
%{_libdir}/pkgconfig/spice.pc
%exclude %{_libdir}/*.a
%exclude %{_libdir}/*.la

%changelog
* Sun Feb 28 2010 Uri Lublin <uril@redhat.com> - 0.3.0-54.el5
 - spice: server: fix wrong access to ring item
Resolves: #559207

* Wed Feb 10 2010 Uri Lublin <uril@redhat.com> - 0.3.0-53.el5
 - spice: server: Being more permissive in video identification
Resolves: #562744
Related: 493375

* Wed Feb 03 2010 Uri Lublin <uril@redhat.com> - 0.3.0-52.el5
 - spice: server: avoid video streaming of small images
Resolves: #558270

* Tue Jan 12 2010 Uri Lublin <uril@redhat.com> - 0.3.0-51.el5
 - spice: server: add red_pipe_clear_device_resources() calls into
   RED_WORKER_MESSAGE_DETACH
Resolves: #551580

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-50.el5
 - spice: server: sending destination public key to client (migration)
Resolves: #549673

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-49.el5
 - spice: sever: increase client timeout
Resolves: #526458

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-48.el5
 - spice: sever: remove assert on nop copy bits
Resolves: #545862

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-47.el5
 - spice: server: heuristic for distinguishing between "real" videos 
   and textual streams
Resolves: #493375

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-46.el5
 - spice: Removed spice client code from tarball
Resolves: #549532

* Tue Dec 22 2009 Uri Lublin <uril@redhat.com> - 0.3.0-45.el5
 - spice: config: prepare for client code removal
Related: #549532

* Tue Oct  6 2009 Uri Lublin <uril@redhat.com> - 0.3.0-44.el5
 - spice: server: disable ssl compression
Resolves: #482111

* Thu Sep 24 2009 Uri Lublin <uril@redhat.com> - 0.3.0-43.el5
 - spice: server: fail net test on invalid values
Resolves: #525055

* Wed Sep  9 2009 Uri Lublin <uril@redhat.com> - 0.3.0-42.el5
 - Fix typo of patch23 file name (missing .patch)
Resolves: #521488

* Wed Sep  9 2009 Uri Lublin <uril@redhat.com> - 0.3.0-41.el5
- spice: server: compress inital screen image
Resolves: #521488

* Sun Sep  6 2009 Uri Lublin <uril@redhat.com> - 0.3.0-40.el5
- spice: server: improve video stream detection
Resolves: #518193 - Error in detecting the video stream on some web sites
- spice: server: improve video streaming in low network bandwidth condition
Resolves: #518388 - Video frames drop in low network bandwidth condition

* Sun Jul 12 2009 Uri Lublin <uril@redhat.com> - 0.3.0-39.el5
- spice: server: improve channel connect/disconnect robustness
Resolves: #508544 - Crash of a VM due to SPICE: ring_remove: ASSERT

* Wed Jul  1 2009 Uri Lublin <uril@redhat.com> - 0.3.0-38.el5
- adjust package description and summary to fit the drop of client
  subpackages in release -34 #507718
Resolves: #507718 - Remove qspice-mozilla subpackage and spicec cli  

* Tue Jun 30 2009 Uri Lublin <uril@redhat.com> - 0.3.0-37.el5
- spice: server: fix is_same_geometry() #508133
Resolves: #508133 - Wrong path geometry comparison result with bad rendering

* Mon Jun 22 2009 Yuval Kashtan <kashtan@redhat.com> - 0.3.0-36.el5
- add 'Requires: libXext-devel' to workaround bug #494249 (#503203)
Resolves: #503203 - qspice-libs-devel doesn't pull libXrandr-devel 

* Thu Jun  8 2009 Dan Kenigsberg <danken@redhat.com> - 0.3.0-33.el5
- change vendor id (#504194)
Resolves: #504194

* Thu May 21 2009 Yuval Kashtan <kashtan@redhat.com> - 0.3.0-32.el5
- updateing qspice to 0.3.0 for kvm (#501819)
Resolves: #501819

* Mon May 04 2009 Yuval Kashtan <ykashtan@redhat.com> - 0.1.0-29.el5
- Compile qspice for 64bit only (#498872)
Resolves: #498872 - qspice server is being compiled for 32bit machines

* Thu Apr 23 2009 Yuval Kashtan <ykashtan@redhat.com> - 0.1.0-28.el5
- First RHEL-5 release (#488580)
- Fix all rpmlint issues (#488580)
Resolves: #488580 - Add qspice package

* Mon Apr 16 2009 Dan Kenigsberg <danken@redhat.com> - 0.1.0-25.git4b474d
- fix bad hash key in spice client cache templates #494638
- fix bug 492322 - client stuck after connection is lost.
- fix bug 492885 - Fix wrong free memory that own by cache.
- add insoftware fast stretching #481891
- add x shared memory support - fix bug 482281 (video in linux is slower)
- fix unsupported vdagent messages handling #494577
- fix window messages handling #494367

* Mon Apr 06 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-22.git999521
- Re-add the Requires lines to -libs-devel, to fix bz#489896 again
- Resolves: bz#489896

* Wed Apr  6 2009 Dan Kenigsberg <danken@redhat.com> - 0.1.0-20.git999521
- Fix pkgconfig

* Wed Jan 28 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-7.git64b798
- Rebuild against newer qpixman/qcairo

* Tue Jan 27 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-6.git64b798
- Update to newer git snapshot: 64b79805304efffdef1297a58937c338f9121fc2

* Mon Jan 12 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-5.gitdc3b10
- Update to newer git snapshot: dc3b1022a88572f77c98d6fd78f560022c70660c

* Mon Jan 12 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-4.git7386c4
- Update to git snapshot as of 2009-01-12
  (git commit 7386c46e1c4c9172384f731d6f1255e2d1315b17)

* Fri Jan 09 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-3
- Add BuildRequires: zip

* Fri Jan 09 2009 Eduardo Habkost <ehabkost@redhat.com> - 0.1.0-2
- Add BuildRequires: libXext-devel

* Fri Jan  9 2008 Soren Sandmann <sandmann@redhat.com> - 0.1.0-1
- Add buildrequires on boost-devel

* Fri Jan  9 2008 Soren Sandmann <sandmann@redhat.com> - 0.1.0-1
- Fix up to deal with the tarball having a different name than the package

* Thu Jan  8 2008 Jon McCann <jmccann@redhat.com> - 0.1.0-1
- Initial package
